<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 30.10</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
</head>

<body onload="onPageLoading()">
    <div class="container">
        <h1 class="text-center">Form Đăng nhập</h1>
        <form id="loginForm">
            <div class="group-control">
                <label>Email Address</label>
                <input type="text" id="inp-email" class="form-control" placeholder="Enter Email" />
                <p style="color:#ccc;">We'll never share your email with anyone else.</p>
            </div>
            <div class="group-control">
                <label>Password</label>
                <input type="password" id="inp-password" class="form-control" placeholder="Password" />
            </div>
            <div class="group-control" style="margin-top:10px;">
                <button type="submit" class="btn btn-primary">Submit</button>
            </div>
        </form>
    </div>
</body>

</html>
<script>
    'use strict';
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
    const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        "use strict";
        var loginForm = document.getElementById("loginForm");
        loginForm.addEventListener("submit", function (e) {
            e.preventDefault(); // Ngăn chặn submit mặc định
            console.log("Submit form!");
            // Bước 0: Tạo đối tượng
            var vObject = {
                email: "",
                password: ""
            }
            // Bước 1: Thu thập dữ liệu
            getDataFromInput(vObject);
            console.log(vObject);
            // Bước 2: Kiểm tra dữ liệu thu thập
            var vCheck = validateData(vObject);
            console.log(vCheck);
            if (vCheck == true) {
                // Bước 3: Xử lý API
                var vXmlHttpLogin = new XMLHttpRequest();
                processAPI(vXmlHttpLogin, vObject);
                // Bước 4: Hiển thị kết quả
                vXmlHttpLogin.onreadystatechange =
                    function () {
                        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                            var vLoginInfo = vXmlHttpLogin.responseText;                            
                            displayData(vLoginInfo);
                        }
                    }
            }

        })
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm hiển thị kết quả
    // Input là dữ liệu cần hiển thị
    function displayData(paramData){
        "use strict";
        console.log(paramData);
    }
    // Hàm xử lý Ajax API
    // Input là đối tượng Request và đối tượng dữ liệu
    function processAPI(paramRequest, paramObject) {
        "use strict";
        paramRequest.open("GET", gBASE_URL + "?" + paramObject.toString(), true);
        paramRequest.send();
    }
    // Hàm kiểm tra email
    // Input là email càn kiểm tra
    // Output là true / false
    function validateEmail(email) {
        var re = /\S+@\S+\.\S+/;
        return re.test(email);
    }
    // Hàm kiểm tra dữ liệu thu thập
    // Input là đối tượng dữ liệu cần kiểm tra
    // Output là true / false
    function validateData(paramObject) {
        "use strict";
        var vEmail = paramObject.email.trim();
        var vPasssWord = paramObject.password.trim();
        var vResult = true;
        // Kiểm tra rỗng
        if (vEmail == "") {
            alert("Email is empty!");
            vResult = false;
        } else {
            // Kiểm tra email hợp lệ
            if (validateEmail(vEmail) == false) {
                alert("Email is not valid!");
                vResult = false;
            }
        }

        if (vPasssWord == "") {
            alert("Password is empty!");
            vResult = false;
        }

        return vResult;
    }
    // Hàm thu thập dữ liệu
    // Input là đối tượng chứa dữ liệu cần thu thập
    function getDataFromInput(paramObject) {
        "use strict";
        var vEmail = document.getElementById("inp-email");
        paramObject.email = vEmail.value;

        var vPasssWord = document.getElementById("inp-password");
        paramObject.password = vPasssWord.value;
    }
</script>